var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from 'react';
import { IsFunc } from 'basic-helper';
import { TransitionGroup, CSSTransition } from 'react-transition-group';
import LoginPanel from './login-panel';
var LoginSelector = function (props) {
    var children = props.children, isLogin = props.isLogin;
    var container;
    switch (true) {
        case isLogin:
            container = IsFunc(children) ? children(props) : children;
            break;
        default:
            container = (React.createElement(LoginPanel, __assign({}, props)));
    }
    return (React.createElement(TransitionGroup, { component: null },
        React.createElement(CSSTransition, { key: isLogin ? 'LOGIN_SUCCESS' : 'NO_LOGIN_YET', classNames: "fade", timeout: 200 }, container)));
};
export default LoginSelector;
