/// <reference types="react" />
import PropTypes from 'prop-types';
import ActionAgent from "../action-agent";
export default class EditProject extends ActionAgent {
    static propTypes: {
        project: PropTypes.Validator<object>;
        onUpdated: PropTypes.Requireable<(...args: any[]) => any>;
        onClose: PropTypes.Validator<(...args: any[]) => any>;
        notify: PropTypes.Validator<(...args: any[]) => any>;
    };
    static defaultProps: {
        onUpdated: () => void;
    };
    state: any;
    formBtns: {
        text: string;
        actingRef: string;
        action: (formRef: any, actingRef: any) => void;
    }[];
    constructor(props: any);
    componentDidMount(): void;
    initData(): Promise<void>;
    updateProject: (nextProject: any, actingRef: any) => Promise<void>;
    deleteProject: (actingRef: any) => Promise<void>;
    render(): JSX.Element;
}
