var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import React from 'react';
import PropTypes from 'prop-types';
import { FormLayout, Loading, ShowModal, Button } from 'ukelli-ui';
import { updatePropject, delPropject } from './apis';
import wrapProjectFormOptions from './project-form';
import ActionAgent from "../action-agent";
var EditProject = /** @class */ (function (_super) {
    __extends(EditProject, _super);
    function EditProject(props) {
        var _this = _super.call(this, props) || this;
        _this.state = __assign(__assign({}, _this.state), { querying: true });
        _this.formBtns = [
            {
                text: '更新',
                actingRef: 'updating',
                action: function (formRef, actingRef) {
                    var isPass = formRef.checkForm().isPass;
                    if (isPass) {
                        _this.updateProject(formRef.value, actingRef);
                    }
                }
            },
        ];
        _this.updateProject = function (nextProject, actingRef) { return __awaiter(_this, void 0, void 0, function () {
            var postData, agentOptions, updateRes, resErr;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        postData = nextProject;
                        agentOptions = {
                            actingRef: actingRef,
                        };
                        return [4 /*yield*/, this.reqAgent(updatePropject, agentOptions)(postData)];
                    case 1:
                        updateRes = _a.sent();
                        resErr = updateRes.err;
                        this.props.notify('更新项目', !resErr, resErr);
                        if (!resErr) {
                            this.props.onUpdated();
                        }
                        return [2 /*return*/];
                }
            });
        }); };
        _this.deleteProject = function (actingRef) { return __awaiter(_this, void 0, void 0, function () {
            var _a, username, project, onClose, queryProject;
            var _this = this;
            return __generator(this, function (_b) {
                _a = this.props, username = _a.username, project = _a.project, onClose = _a.onClose, queryProject = _a.queryProject;
                ShowModal({
                    title: '确定删除项目？',
                    type: 'confirm',
                    width: 300,
                    confirmText: '一旦删除，不可恢复, 同时删除相关的所有资源.',
                    onConfirm: function (isSure) { return __awaiter(_this, void 0, void 0, function () {
                        var delRes;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    if (!isSure)
                                        return [2 /*return*/];
                                    return [4 /*yield*/, this.reqAgent(delPropject, {
                                            actingRef: actingRef
                                        })({
                                            username: username,
                                            projId: project.id
                                        })];
                                case 1:
                                    delRes = _a.sent();
                                    this.props.notify('删除', !delRes.err, delRes.err);
                                    if (!delRes.err) {
                                        onClose();
                                        queryProject();
                                    }
                                    return [2 /*return*/];
                            }
                        });
                    }); }
                });
                return [2 /*return*/];
            });
        }); };
        return _this;
    }
    EditProject.prototype.componentDidMount = function () {
        this.initData();
    };
    EditProject.prototype.initData = function () {
        return __awaiter(this, void 0, void 0, function () {
            var getProject, project, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        getProject = this.props.getProject;
                        project = getProject();
                        _a = this;
                        return [4 /*yield*/, wrapProjectFormOptions(project)];
                    case 1:
                        _a.formOptions = _b.sent();
                        this.setState({
                            querying: false
                        });
                        return [2 /*return*/];
                }
            });
        });
    };
    EditProject.prototype.render = function () {
        var _this = this;
        var _a = this.state, querying = _a.querying, deleting = _a.deleting, updating = _a.updating;
        var deleteBtn = (React.createElement("div", { className: "text-center" },
            React.createElement("hr", null),
            React.createElement("p", null,
                React.createElement(Button, { text: "\u5220\u9664\u8BE5\u9879\u76EE", className: "btn red flat", disabled: deleting, onClick: function (e) { return _this.deleteProject('deleting'); } })),
            React.createElement("p", { className: "form-tip" }, "\u4E0D\u53EF\u6062\u590D, \u540C\u65F6\u5220\u9664\u76F8\u5173\u7684\u6240\u6709\u8D44\u6E90")));
        return (React.createElement(Loading, { loading: querying },
            React.createElement(FormLayout, { formOptions: this.formOptions, updating: updating, childrenAfterForm: deleteBtn, formBtns: this.formBtns })));
    };
    EditProject.propTypes = {
        project: PropTypes.object.isRequired,
        onUpdated: PropTypes.func,
        onClose: PropTypes.func.isRequired,
        notify: PropTypes.func.isRequired,
    };
    EditProject.defaultProps = {
        onUpdated: function () { }
    };
    return EditProject;
}(ActionAgent));
export default EditProject;
