import React from 'react';
import { DropdownWrapperProps } from 'ukelli-ui/core/selector/dropdown-wrapper';
export interface StatusbarConfigItem {
    title: string;
    icon?: string;
    pureIcon?: string;
    overlay: DropdownWrapperProps['overlay'];
    component: JSX.Element;
    action: Function;
}
export interface StatsbarProps {
    statusbarConfig: StatusbarConfigItem[];
}
declare const Statusbar: React.SFC<StatsbarProps>;
export default Statusbar;
