/// <reference types="react" />
import PropTypes from 'prop-types';
import { TableColumns } from 'ukelli-ui/core/record-render/table-body';
import ActionAgent from "../action-agent";
declare class AssetsManager extends ActionAgent {
    static propTypes: {
        notify: PropTypes.Validator<(...args: any[]) => any>;
        getProject: PropTypes.Validator<(...args: any[]) => any>;
        username: PropTypes.Requireable<string>;
        releasable: PropTypes.Requireable<boolean>;
    };
    static defaultProps: {
        releasable: boolean;
    };
    columns: TableColumns;
    constructor(props: any);
    componentDidMount(): void;
    comfirmRelease: (options: any) => void;
    queryData(): Promise<void>;
    onReleased: () => void;
    objToArr(obj: any): never[];
    render(): JSX.Element;
}
export default AssetsManager;
