/// <reference types="react" />
import PropTypes from 'prop-types';
import ActionAgent from "../action-agent";
export default class CreateAsset extends ActionAgent {
    static propTypes: {
        project: PropTypes.Requireable<object>;
        projId: PropTypes.Requireable<string>;
        onSuccess: PropTypes.Validator<(...args: any[]) => any>;
    };
    state: {
        uploading: boolean;
    };
    constructor(props: any);
    formBtns: {
        actingRef: string;
        action: (formRef: any, actingRef: any) => Promise<void>;
        text: string;
    }[];
    render(): JSX.Element;
}
