/**
 * 项目管理
 */
import { Component } from 'react';
import PropTypes from 'prop-types';
declare class ProjectManager extends Component {
    static propTypes: {
        getProject: PropTypes.Validator<(...args: any[]) => any>;
        queryProject: PropTypes.Validator<(...args: any[]) => any>;
        defaultTab: PropTypes.Requireable<string>;
    };
    static defaultProps: {
        defaultTab: string;
    };
    constructor(props: any);
    onCreatedAsset(): void;
    onUpdateProject(): void;
    authFilter(): void;
    applyToJoin(projId: any): Promise<void>;
    render(): JSX.Element;
}
export default ProjectManager;
