var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
/* eslint-disable default-case */
import React from 'react';
import { Icon, PureIcon, DropdownWrapper } from '../ui-refs';
var DisplayDOM = function (_a) {
    var onClick = _a.onClick, pureIcon = _a.pureIcon, icon = _a.icon, title = _a.title;
    var I = pureIcon ? React.createElement(PureIcon, { n: pureIcon }) : React.createElement(Icon, { n: icon });
    return (React.createElement("span", { onClick: onClick },
        I,
        title && React.createElement("span", { className: "ml5" }, title)));
};
var Statusbar = function (props) {
    var statusbarConfig = props.statusbarConfig, otherProps = __rest(props, ["statusbarConfig"]);
    return (React.createElement("div", { className: "status-container" }, statusbarConfig.map(function (item) {
        var title = item.title, icon = item.icon, pureIcon = item.pureIcon, overlay = item.overlay, component = item.component, action = item.action;
        var con;
        switch (true) {
            case !!component:
                con = component;
                break;
            case !!overlay:
                con = (React.createElement(DropdownWrapper, { position: "right", overlay: function (options) { return overlay(__assign(__assign({}, otherProps), options)); } },
                    React.createElement(DisplayDOM, { title: title, icon: icon, pureIcon: pureIcon })));
                break;
            case !!action:
                con = React.createElement(DisplayDOM, { title: title, icon: icon, pureIcon: pureIcon });
                break;
        }
        return (React.createElement("span", { className: "item", onClick: action, key: icon + "_" + title }, con));
    })));
};
export default Statusbar;
