import React, { Component } from 'react';
export interface VersionInfo {
    packageVersion: string;
    buildVersion: string;
    version: string;
    buildDate: string;
    gitHash: string;
}
export interface VersionCheckerProps {
    versionInfo: VersionInfo;
    versionUrl: string;
}
export interface VersionDisplayerProps {
    $T: (str: string) => string;
    /** 版本内容 */
    versionInfo: VersionInfo;
}
declare class VersionChecker extends Component<VersionCheckerProps> {
    __unmount: any;
    timer: any;
    errorCount: any;
    constructor(props: any);
    componentDidMount(): void;
    componentWillUnmount(): void;
    _clear: () => void;
    getVersion: () => void;
    reload: () => void;
    render: () => JSX.Element;
}
declare const VersionDisplayer: React.SFC<VersionDisplayerProps>;
export { VersionChecker };
export default VersionDisplayer;
