import React from 'react';
import { Table, Menus, ShowModal } from '../ui-refs';
import records from './data';
var columns = [
    {
        key: 'shortcut',
        title: '快捷键'
    },
    {
        key: 'desc',
        title: '描述'
    }
];
var ShortcutHelp = function () {
    return React.createElement(Table, { columns: columns, records: records });
};
var showShortcut = function () {
    ShowModal({
        children: React.createElement(ShortcutHelp, null),
        title: '键盘快捷键说明',
        width: 640
    });
};
var ShortcutDesc = function () {
    return (React.createElement(Menus, { data: [
            {
                text: '快捷键说明',
                action: function () { return showShortcut(); }
            },
        ] }));
};
export { showShortcut, ShortcutDesc };
export default ShortcutHelp;
