import { TableKeyMapper } from 'ukelli-ui/core/record-render/table-body';
declare const conditionData: ({
    type: string;
    value: string;
    ref: string;
    refs?: undefined;
    title?: undefined;
    tips?: undefined;
    defaultValue?: undefined;
    values?: undefined;
    inputType?: undefined;
    required?: undefined;
    range?: undefined;
    refu?: undefined;
    refForS?: undefined;
    defaultValueForS?: undefined;
    isNum?: undefined;
} | {
    refs: string[];
    type: string;
    title: string;
    tips: string;
    defaultValue: never[];
    value?: undefined;
    ref?: undefined;
    values?: undefined;
    inputType?: undefined;
    required?: undefined;
    range?: undefined;
    refu?: undefined;
    refForS?: undefined;
    defaultValueForS?: undefined;
    isNum?: undefined;
} | {
    ref: string;
    type: string;
    title: string;
    values: {
        val1: string;
        val2: string;
        val3: string;
        val4: string;
        value1?: undefined;
        value2?: undefined;
        value3?: undefined;
        1?: undefined;
        2?: undefined;
        3?: undefined;
    };
    value?: undefined;
    refs?: undefined;
    tips?: undefined;
    defaultValue?: undefined;
    inputType?: undefined;
    required?: undefined;
    range?: undefined;
    refu?: undefined;
    refForS?: undefined;
    defaultValueForS?: undefined;
    isNum?: undefined;
} | {
    ref: string;
    type: string;
    title: string;
    values: {
        value1: string;
        value2: string;
        value3: string;
        val1?: undefined;
        val2?: undefined;
        val3?: undefined;
        val4?: undefined;
        1?: undefined;
        2?: undefined;
        3?: undefined;
    };
    value?: undefined;
    refs?: undefined;
    tips?: undefined;
    defaultValue?: undefined;
    inputType?: undefined;
    required?: undefined;
    range?: undefined;
    refu?: undefined;
    refForS?: undefined;
    defaultValueForS?: undefined;
    isNum?: undefined;
} | {
    ref: string;
    type: string;
    inputType: string;
    required: boolean;
    title: string;
    values: {
        value1: string;
        value2: string;
        value3: string;
        val1?: undefined;
        val2?: undefined;
        val3?: undefined;
        val4?: undefined;
        1?: undefined;
        2?: undefined;
        3?: undefined;
    };
    value?: undefined;
    refs?: undefined;
    tips?: undefined;
    defaultValue?: undefined;
    range?: undefined;
    refu?: undefined;
    refForS?: undefined;
    defaultValueForS?: undefined;
    isNum?: undefined;
} | {
    refs: string[];
    type: string;
    title: string;
    range: number[];
    value?: undefined;
    ref?: undefined;
    tips?: undefined;
    defaultValue?: undefined;
    values?: undefined;
    inputType?: undefined;
    required?: undefined;
    refu?: undefined;
    refForS?: undefined;
    defaultValueForS?: undefined;
    isNum?: undefined;
} | {
    refu: {
        refuValue1: string;
        refuValue2: string;
        refuValue3: string;
    };
    type: string;
    tips: string;
    title: string;
    value?: undefined;
    ref?: undefined;
    refs?: undefined;
    defaultValue?: undefined;
    values?: undefined;
    inputType?: undefined;
    required?: undefined;
    range?: undefined;
    refForS?: undefined;
    defaultValueForS?: undefined;
    isNum?: undefined;
} | {
    ref: string;
    refForS: string;
    type: string;
    defaultValueForS: number;
    defaultValue: string;
    isNum: boolean;
    values: {
        1: string;
        2: string;
        3: string;
        val1?: undefined;
        val2?: undefined;
        val3?: undefined;
        val4?: undefined;
        value1?: undefined;
        value2?: undefined;
        value3?: undefined;
    };
    tips: string;
    title: string;
    value?: undefined;
    refs?: undefined;
    inputType?: undefined;
    required?: undefined;
    range?: undefined;
    refu?: undefined;
} | {
    ref: string;
    type: string;
    title: string;
    defaultValue: boolean;
    value?: undefined;
    refs?: undefined;
    tips?: undefined;
    values?: undefined;
    inputType?: undefined;
    required?: undefined;
    range?: undefined;
    refu?: undefined;
    refForS?: undefined;
    defaultValueForS?: undefined;
    isNum?: undefined;
})[];
declare const getTestData: () => Promise<unknown>;
declare const keyFieldsForReport: TableKeyMapper;
export { getTestData, keyFieldsForReport, conditionData };
