var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var defaultPagin = {
    active: true,
    total: 0,
    pIdx: 0,
    pSize: 10
};
/**
 * 用于包装具体业务接口的分页字段
 */
var paginTransfer = {
    active: 'active',
    total: 'total',
    pIdx: 'pIdx',
    pSize: 'pSize'
};
export function getDefPagin() {
    return __assign({}, defaultPagin);
}
export function getPaginMapper() {
    return __assign({}, paginTransfer);
}
export function setDefPagin(nextState) {
    return Object.assign(defaultPagin, nextState);
}
export function setPaginMapper(nextState) {
    return Object.assign(paginTransfer, nextState);
}
export function paginHelper(config) {
    if (config === void 0) { config = defaultPagin; }
    var active = config.active, total = config.total, pIdx = config.pIdx, pSize = config.pSize;
    return {
        active: active,
        total: total,
        pIdx: pIdx,
        pSize: pSize
    };
}
